# -*- coding: utf-8 -*-
"""afterlearningciar

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1cy5ylRyhjLT5X9KAwFZBoQgxVegPD2Dc
"""

# Commented out IPython magic to ensure Python compatibility.
# Install TensorFlow
# !pip install -q tensorflow-gpu==2.0.0-beta1

try:
#   %tensorflow_version 2.x  # Colab only.
except Exception:
  pass

import tensorflow as tf
print(tf.__version__)

# additional imports

import numpy as np
import matplotlib.pyplot as plt
from tensorflow.keras.layers import Input, Conv2D, Dense, Flatten, Dropout, GlobalMaxPooling2D
from tensorflow.keras.models import Model
from keras.activations import *
from numpy.polynomial import Polynomial

# Load in the data
cifar10 = tf.keras.datasets.cifar10

(x_train, y_train), (x_test, y_test) = cifar10.load_data()
x_train, x_test = x_train / 255.0, x_test / 255.0
y_train, y_test = y_train.flatten(), y_test.flatten()
print("x_train.shape:", x_train.shape)
print("y_train.shape", y_train.shape)

# number of classes
K = len(set(y_train))
print("number of classes:", K)

from keras.activations import *
import numpy as np
from numpy.polynomial import Polynomial
from sklearn.datasets import make_blobs
from tensorflow.keras.utils import get_custom_objects

def custom_activation(x):
    return (x**2) +x
get_custom_objects().update({'custom_activation': custom_activation})

from tensorflow.keras.models import Model

# Build the model using the functional API

net =3
model = [0] *net
for j in range(0,net): 
  i = Input(shape=x_train[0].shape)
  x = Conv2D(32, (3, 3), strides=2, activation='custom_activation')(i)
  x = Conv2D(64, (3, 3), strides=2, activation='custom_activation')(x)
  x = Conv2D(128, (3, 3), strides=2, activation='custom_activation')(x)
  x = Flatten()(x)
  x = Dropout(0.5)(x)
  x = Dense(1024, activation='custom_activation')(x)
  x = Dropout(0.2)(x)
  x = Dense(K, activation='softmax')(x)
  model[j]= Model(i, x)
  print(f'Individual Net : {j+1}')
  model[j].compile(optimizer='adam',
              loss='sparse_categorical_crossentropy',
              metrics=['accuracy'])
  r = model[j].fit(x_train, y_train, validation_data=(x_test, y_test), epochs=15)

import numpy as np
results = np.zeros((10000,10)) 

r=model[0].predict(x_test)
#print(y_test.shape)
#print(r.shape)
#print(results.shape)
for j in range(0,net):
    results = results + model[j].predict(x_test)

res = np.argmax(results,axis = 1)
#y_labels= np.argmax(y_test,axis = 1)
#print(res)
#print(y_test)

from sklearn.metrics import accuracy_score
import numpy
y_test = numpy.array(y_test)
print(accuracy_score(res,y_test ))
print ("tottal acc: " + str(accuracy_score(res,y_test)))

print ("Number of Nets: " + str(net))

# Plot accuracy per iteration
plt.plot(r.history['accuracy'], label='acc')
plt.plot(r.history['val_accuracy'], label='val_acc')
plt.legend()

# Plot confusion matrix
from sklearn.metrics import confusion_matrix
import itertools

def plot_confusion_matrix(cm, classes,
                          normalize=False,
                          title='Confusion matrix',
                          cmap=plt.cm.Blues):
  """
  This function prints and plots the confusion matrix.
  Normalization can be applied by setting `normalize=True`.
  """
  if normalize:
      cm = cm.astype('float') / cm.sum(axis=1)[:, np.newaxis]
      print("Normalized confusion matrix")
  else:
      print('Confusion matrix, without normalization')

  print(cm)

  plt.imshow(cm, interpolation='nearest', cmap=cmap)
  plt.title(title)
  plt.colorbar()
  tick_marks = np.arange(len(classes))
  plt.xticks(tick_marks, classes, rotation=45)
  plt.yticks(tick_marks, classes)

  fmt = '.2f' if normalize else 'd'
  thresh = cm.max() / 2.
  for i, j in itertools.product(range(cm.shape[0]), range(cm.shape[1])):
      plt.text(j, i, format(cm[i, j], fmt),
               horizontalalignment="center",
               color="white" if cm[i, j] > thresh else "black")

  plt.tight_layout()
  plt.ylabel('True label')
  plt.xlabel('Predicted label')
  plt.show()


p_test = model.predict(x_test).argmax(axis=1)
cm = confusion_matrix(y_test, p_test)
plot_confusion_matrix(cm, list(range(10)))

# label mapping
labels = '''airplane
automobile
bird
cat
deer
dog
frog
horse
ship
truck'''.split()

# Show some misclassified examples
# TODO: add label names
misclassified_idx = np.where(p_test != y_test)[0]
i = np.random.choice(misclassified_idx)
plt.imshow(x_test[i], cmap='gray')
plt.title("True label: %s Predicted: %s" % (labels[y_test[i]], labels[p_test[i]]));