# -*- coding: utf-8 -*-
"""RELU.CIF.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1AV6gevNkee2XWN7W7otQf5pzzS3WCnp2
"""

# Commented out IPython magic to ensure Python compatibility.
# Install TensorFlow
# !pip install -q tensorflow-gpu==2.0.0-beta1

try:
#   %tensorflow_version 2.x  # Colab only.
except Exception:
  pass

import tensorflow as tf
print(tf.__version__)
import numpy as np
import matplotlib.pyplot as plt
from tensorflow.keras.layers import Input, Conv2D, Dense, Flatten, Dropout, GlobalMaxPooling2D
from tensorflow.keras.models import Model
from keras.activations import *
from numpy.polynomial import Polynomial
# Load in the data
cifar10 = tf.keras.datasets.cifar10

(x_train, y_train), (x_test, y_test) = cifar10.load_data()
x_train, x_test = x_train / 255.0, x_test / 255.0
y_train, y_test = y_train.flatten(), y_test.flatten()
print("x_train.shape:", x_train.shape)
print("y_train.shape", y_train.shape)
# number of classes
K = len(set(y_train))
print("number of classes:", K)
from keras.activations import *
import numpy as np
from numpy.polynomial import Polynomial
from sklearn.datasets import make_blobs
from tensorflow.keras.utils import get_custom_objects

def custom_activation(x):
    return (x**2) +x
get_custom_objects().update({'custom_activation': custom_activation})
from tensorflow.keras.models import Model

# Build the model using the functional API

net =1
model = [0] *net
for j in range(0,net): 
  i = Input(shape=x_train[0].shape)
  x = Conv2D(32, (3, 3), strides=2, activation='relu')(i)
  x = Conv2D(64, (3, 3), strides=2, activation='relu')(x)
  x = Conv2D(128, (3, 3), strides=2, activation='relu')(x)
  x = Flatten()(x)
  x = Dropout(0.5)(x)
  x = Dense(1024, activation='relu')(x)
  x = Dropout(0.2)(x)
  x = Dense(K, activation='softmax')(x)
  model[j]= Model(i, x)
  print(f'Individual Net : {j+1}')
  model[j].compile(optimizer='adam',
              loss='sparse_categorical_crossentropy',
              metrics=['accuracy'])
  r = model[j].fit(x_train, y_train, validation_data=(x_test, y_test), epochs=15)

import numpy as np
results = np.zeros((10000,10)) 

r=model[0].predict(x_test)
#print(y_test.shape)
#print(r.shape)
#print(results.shape)
for j in range(0,net):
    
    results = results + model[j].predict(x_test)

res = np.argmax(results,axis = 1)
#y_labels= np.argmax(y_test,axis = 1)
#print(res)
#print(y_test)

from sklearn.metrics import accuracy_score
from sklearn.metrics import precision_score
from sklearn.metrics import recall_score
from sklearn.metrics import f1_score
import numpy

y_test = numpy.array(y_test)
print(accuracy_score(res,y_test ))
print(accuracy_score(res,y_test ))
print ("Total accuracy: " + str(accuracy_score(res,y_test )))
print ("Precision (average = None)" + str(precision_score(res,y_test, average=None)))
print ("Recall (average = None)" + str(recall_score(res,y_test,  average=None)))
print ("F1 Score (average = None)" + str(f1_score(res,y_test, average=None)))